% gui_setval(akt_han, akt_val)
%
% Set value of slider specified by akt_han to value akt_val
% und automatically update corresponding edit field
% (C) Klaus Lichtenegger, 2001;
% based on routines by W. Kernbichler

function gui_setval(akt_han, akt_val);

  % get slider min-max-value
  max_val = get(akt_han, 'Max');
  min_val = get(akt_han, 'Min');
  
  % set slider value: 
  if akt_val>max_val
    set(akt_han, 'Value', max_val);
  elseif akt_val<min_val
    set(akt_han, 'Value', min_val);
  else
    set(akt_han, 'Value', akt_val);
  end % if
    
  % udate edit field
  if isfield(get(akt_han,'userdata'),'updatehandle')
    updatehandle   = gui_get_userdata(akt_han,'updatehandle');
    updateproperty = gui_get_userdata(akt_han,'updateproperty');     
    if ~isempty(updatehandle)
      from_prop = updateproperty{1};
      to_prop   = updateproperty{2};
      chfunc    = updateproperty{3};
      e_str = [ 'get(akt_han,''',from_prop,''')' ];
      e_str = strrep(chfunc,'##',e_str);
      e_str = [ 'set(updatehandle,''',to_prop,''',',e_str,');' ];
      eval( e_str );
    end % if
  end % if


